/*===========================================================================
*
*                            PUBLIC DOMAIN NOTICE
*               National Center for Biotechnology Information
*
*  This software/database is a "United States Government Work" under the
*  terms of the United States Copyright Act.  It was written as part of
*  the author's official duties as a United States Government employee and
*  thus cannot be copyrighted.  This software/database is freely available
*  to the public for use. The National Library of Medicine and the U.S.
*  Government have not placed any restriction on its use or reproduction.
*
*  Although all reasonable efforts have been taken to ensure the accuracy
*  and reliability of the software and data, the NLM and the U.S.
*  Government do not and cannot warrant the performance or results that
*  may be obtained by using this software or data. The NLM and the U.S.
*  Government disclaim all warranties, express or implied, including
*  warranties of performance, merchantability or fitness for any particular
*  purpose.
*
*  Please cite the author in any work or product based on this material.
*
* ===========================================================================
*
*/

#ifndef _h_log_priv_
#define _h_log_priv_

#ifndef _h_klib_log_
#include <klib/log.h>
#endif

#ifndef _h_klib_rc_
#include <klib/rc.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* some defaults */

/*--------------------------------------------------------------------------
 * Log
 *  global logging
 */

/* GetRCModuleText
 */
const char *GetRCModuleText ( enum RCModule mod );

/* GetRCTargetText
 */
const char *GetRCTargetText ( enum RCTarget targ );

/* GetRCContextText
 */
const char *GetRCContextText ( enum RCContext ctx );

/* GetRCObjectText
 *  obj can be RCTarget or RCObject
 */
const char *GetRCObjectText ( int obj );

/* GetRCStateText
 */
const char *GetRCStateText ( enum RCState state );


/* GetRCModuleIdxText
 */
const char *GetRCModuleIdxText ( enum RCModule mod );

/* GetRCTargetIdxText
 */
const char *GetRCTargetIdxText ( enum RCTarget targ );

/* GetRCContextIdxText
 */
const char *GetRCContextIdxText ( enum RCContext ctx );

/* GetRCObjectIdxText
 *  obj can be RCTarget or RCObject
 */
const char *GetRCObjectIdxText ( int obj );

/* GetRCStateIdxText
 */
const char *GetRCStateIdxText ( enum RCState state );

#ifdef __cplusplus
}
#endif

#endif /* _h_log_priv_ */
